#ifndef MEM_H
#define MEM_H  /* block for forever(or nest) loop */


#define MALLOC(x)   malloc(x)
#define FREE(x)     free(x)

#define STRDUP(x)   strdup(x)



#if 0
#define NBLK(radix, x)  ((x)/(radix)+(((x)%(radix))!=0))
#define NBLK512(x)      (NBLK(512,(x))*512)
#define BCEIL(x, blen)  (((x)/(blen)+1)*(blen))
#endif

/*
#define BCEIL(x, blen)  ((( (x) + (blen) -1)/ (blen) )* (blen) )
*/
/*
#define NBCEIL(x, blen)  (( (x) + (blen) -1)/ (blen) )
#define BCEIL(x, blen)   (NBCEIL( (x), (blen) )* (blen) )
*/

#define alloc_str(x)    ((char*)MALLOC(sizeof(char)*BCEIL((x)+1, STRING_BLEN)))

#define XSTRDUP(d,s) \
    ((d=alloc_str(strlen(s)))==NULL ? NULL : strcpy(d, s), d)





#ifdef USE_MLOCK

#define MLOCK(addr, len)    mlock((void*)addr, len)

#define XMLOCK(addr, len)   { \
        if(mlock((void*)addr, len)<0) { \
            Trace("fail mlock(%p,%d) (%d)\n", (char*)addr, len, errno); \
        } \
        else { \
        } \
    }

#ifdef MALLOC
#undef MALLOC
#endif
#define MALLOC(len) kotetu_mem_alloc_lock(len)

#else

#define MLOCK(addr, len)        /* nothing */

#endif

void* kotetu_mem_alloc_lock(int);

#endif /* MEM_H*/

